Attribute VB_Name = "ModCallback"
Option Explicit
Private Declare Function ShellExecuteEx Lib "shell32" Alias "ShellExecuteExW" (ByRef lpExecInfo As SHELLEXECUTEINFO) As Long
Private Declare Function WaitForSingleObject Lib "kernel32" (ByVal hHandle As Long, ByVal dwMilliseconds As Long) As Long
Private Declare Function CloseHandle Lib "kernel32" (ByVal hObject As Long) As Long
Private Declare Function DispCallFunc Lib "oleaut32" (ByVal pvInstance As Long, ByVal oVft As Long, ByVal CallConv As Long, ByVal vtReturn As Integer, ByVal cActuals As Long, ByVal prgvt As Long, ByVal prgpvarg As Long, ByRef pvargResult As Variant) As Long
Private Declare Function TipGetProjName Lib "vba6.dll" (ByVal hProj As Long, ByVal bstrName As Long) As Long
Private Type SHELLEXECUTEINFO
cbSize As Long
fMask As Long
hWnd As Long
lpVerb As Long
lpFile As Long
lpParameters As Long
lpDirectory As Long
nShow As Long
hInstApp As Long
lpIDList As Long
lpClass As Long
hkeyClass As Long
dwHotKey As Long
hIcon As Long
hProcess As Long
End Type
Private Const SEE_MASK_NOCLOSEPROCESS As Long = &H40
Private Const SEE_MASK_FLAG_NO_UI As Long = &H400
Private Const SW_SHOWDEFAULT As Long = 10
Private Const INFINITE As Long = (-1)
Private Const WAIT_OBJECT_0 As Long = &H0
Public pfnTipFinishExe2 As Long
Public pVBInstance As VBIDE.VBE

Public Function TipFinishExe2_user(ByVal pVBProjectNative As Long, ByVal lUnused As Long) As Long
On Error GoTo CATCH_EXCEPTION
PauseHook pfnTipFinishExe2
MakeEvent pVBProjectNative, "LinkBefore"
TipFinishExe2_user = CallByPointer(pfnTipFinishExe2, vbLong, pVBProjectNative, lUnused)
MakeEvent pVBProjectNative, "LinkAfter"
ResumeHook pfnTipFinishExe2
Exit Function
CATCH_EXCEPTION:
End Function

Private Function MakeEvent(ByVal pVBProjectNative As Long, ByRef sEventName As String) As Boolean
Dim pVBProject As VBProject
Dim sEvent As String
Dim shInfo As SHELLEXECUTEINFO
Dim lStatus As Long
On Error GoTo CATCH_EXCEPTION
Set pVBProject = GetProjectFromNativeProject(pVBProjectNative)
If pVBProject Is Nothing Then Exit Function
On Error Resume Next
With pVBProject
If .ReadProperty("TAT", sEventName) = vbNullString Then
    sEvent = .ReadProperty("VBCompiler", sEventName)
Else
    sEvent = .ReadProperty("TAT", sEventName)
End If
End With
On Error GoTo -1
If Len(sEvent) = 0 Then Exit Function
On Error GoTo CATCH_EXCEPTION
shInfo.cbSize = LenB(shInfo)
shInfo.lpFile = StrPtr(sEvent)
shInfo.fMask = SEE_MASK_NOCLOSEPROCESS Or SEE_MASK_FLAG_NO_UI
shInfo.nShow = SW_SHOWDEFAULT
lStatus = ShellExecuteEx(shInfo)
If lStatus = 0 Then Exit Function
lStatus = WaitForSingleObject(shInfo.hProcess, INFINITE)
If lStatus <> WAIT_OBJECT_0 Then
    CloseHandle shInfo.hProcess
    Exit Function
End If
CloseHandle shInfo.hProcess
MakeEvent = True
CATCH_EXCEPTION:
End Function

Private Function GetProjectFromNativeProject(ByVal pVBProjectNative As Long) As VBProject
Dim pProj As VBProject
Dim sName As String
sName = GetProjectName(pVBProjectNative)
For Each pProj In pVBInstance.VBProjects
    If pProj.Name = sName Then
        Set GetProjectFromNativeProject = pProj
        Exit For
    End If
Next pProj
End Function

Private Function GetProjectName(ByVal pVBProjectNative As Long) As String
Dim hr As Long
hr = TipGetProjName(pVBProjectNative, VarPtr(GetProjectName))
If hr < 0 Then Err.Raise hr
End Function

Private Function CallByPointer(ByVal pFunc As Long, ByVal lRetType As VbVarType, ParamArray vParams() As Variant) As Variant
Dim iTypes() As Integer: Dim lList() As Long
Dim vParam() As Variant: Dim lIndex As Long
Dim pList As Long: Dim pTypes As Long
Dim ResultCall As Long
Const CC_STDCALL As Long = 4
If LBound(vParams) <= UBound(vParams) Then
    ReDim lList(LBound(vParams) To UBound(vParams))
    ReDim iTypes(LBound(vParams) To UBound(vParams))
    ReDim vParam(LBound(vParams) To UBound(vParams))
    For lIndex = LBound(vParams) To UBound(vParams)
        vParam(lIndex) = vParams(lIndex)
        lList(lIndex) = VarPtr(vParam(lIndex))
        iTypes(lIndex) = VarType(vParam(lIndex))
    Next lIndex
    pList = VarPtr(lList(LBound(lList)))
    pTypes = VarPtr(iTypes(LBound(iTypes)))
End If
ResultCall = DispCallFunc(0, pFunc, CC_STDCALL, lRetType, UBound(vParams) - LBound(vParams) + 1, ByVal pTypes, ByVal pList, CallByPointer)
If ResultCall Then Err.Raise 5: Exit Function
End Function
